package com.bocloud.fms.booter.controller;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.common.model.BocloudResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.ExceptionHandler;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * @author hufy
 */
public class FlowBaseController {

    Logger logger = LoggerFactory.getLogger(this.getClass());

    /**
     * 基于@ExceptionHandler异常处理
     */
    @ExceptionHandler
    public void exp(HttpServletRequest request, Exception ex, HttpServletResponse response) {
        BocloudResult bocloudResult = new BocloudResult(false, ex.getMessage());
        logger.error(ex.getMessage());
        try {
            response.getWriter().write(JSONObject.toJSONString(bocloudResult));
        } catch (IOException e) {
            logger.error("出现io流异常", e);
        }
    }
}
