package com.bocloud.fms.booter.controller;

import com.bocloud.common.model.BocloudResult;
import com.bocloud.fms.intf.FlowVariableService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 流程参数变量
 *
 * @author zhangyf
 * @since 2020-09-02
 */
@RestController
@Api(value = "流程参数变量", tags = "流程参数变量")
@RequestMapping({"/v1/variables"})
public class FlowVariableController extends FlowBaseController {

    private final FlowVariableService flowVariableService;

    public FlowVariableController(FlowVariableService flowVariableService) {
        this.flowVariableService = flowVariableService;
    }

    /**
     * 流程参数变量列表
     *
     * @param type
     * @return
     */
    @GetMapping
    @ApiOperation(value = "流程参数变量列表", response = BocloudResult.class, produces = MediaType.APPLICATION_JSON_VALUE)
    public BocloudResult list(String type) {
        return new BocloudResult(true, flowVariableService.listByType(type), "SUCCESS");
    }

}
