package com.bocloud.fms.entity;

import com.bocloud.common.model.RequestContext;
import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.IgnoreAll;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.io.Serializable;

/**
 * 任务参与者实体类
 *
 * @author hufy
 */
@Data
@EqualsAndHashCode(callSuper = true)
@NoArgsConstructor
@AllArgsConstructor
@Table("wf_node_actor")
public class FlowNodeActor extends Generic implements Serializable {

    @IgnoreAll
    private static final long serialVersionUID = 2969915022122094614L;

    /**
     * 主键id
     */
    @PK(PKStrategy.AUTO)
    private Long id;

    /**
     * 关联的任务ID
     */
    @Column("node_id")
    private Long nodeId;
    /**
     * 关联的参与者ID（参与者可以为用户、部门、角色）
     */
    @Column("actor_id")
    private Long actorId;

    /**
     * 流程实例id
     */
    @Column("instance_id")
    private Long instanceId;
    /**
     * 是否已删除
     */
    @Column("is_deleted")
    private Boolean deleted;

    /**
     * 当前用户类型
     */
    @Column("actor_catalog")
    private RequestContext.Catalog actorCatalog;

}
