package com.bocloud.fms.internel.entity;

import com.bocloud.entity.annotations.Column;
import com.bocloud.entity.annotations.PK;
import com.bocloud.entity.annotations.Table;
import com.bocloud.entity.bean.Generic;
import com.bocloud.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 租户用户收藏夹
 *
 * @author tyl
 * @time 2020/2/26 周三 17:22
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("favorite")
public class Favorite extends Generic {
    @PK(value = PKStrategy.AUTO)
    private Long id; //收藏夹id
    @Column("category")
    private Category category; //账号类型：Tenant、User
    @Column("target")
    private Long target; //目标账号id
    @Column("service_id")
    private Long serviceId;//服务id
    @Column("priority")
    private Integer priority;//收藏夹排序字段

    public Favorite(Long id, Category category, Long target, Long serviceId) {
        this.id = id;
        this.category = category;
        this.target = target;
        this.serviceId = serviceId;
    }

    public enum Category {
        Tenant, //租户
        User,//用户
    }
}
