package com.bocloud.fms.model;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

/**
 * sku数据模型
 *
 * @author wangyu
 * @version 1.0
 * @since 2020年4月13日
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class ElementModel {

    // skuId
    private Long skuId;

    // 申请数量
    private Integer count;
    // 折扣率
    private BigDecimal ratio;
    // 商品价格
    private BigDecimal price;

    // 服务code
    private String serviceCode;
    // 规格详情
    private List<SpecModel> specs;

    private Long categoryId;

    // 类型
    private String category;
    // element uuid，用于标识磁盘
    private String uuid;
}
