package com.bocloud.fms.repository;

import com.bocloud.common.utils.MapTools;
import com.bocloud.fms.entity.FlowNodeActor;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author hufy 任务参与者实体类
 * @since 1.0
 */
@Repository
public class FlowNodeActorRepository extends BasicGenericDao<FlowNodeActor, Long> {

    public FlowNodeActorRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    public void removeTaskActor(Long taskId, Long... actors) {
        String sql = "delete wf_node_actor where node_id = ? and actor_id in (?)";
        Long[] actorIds = new Long[actors.length];
        System.arraycopy(actors, 0, actorIds, 0, actors.length);
        this.getJdbcTemplate().update(sql, taskId, actorIds);
    }

    public List<FlowNodeActor> getTaskActorsByTaskId(Long taskId) {
        String sql = "select * from wf_node_actor where node_id = :taskId";
        return this.list(FlowNodeActor.class, sql, MapTools.simpleMap("taskId", taskId));
    }

}
