package com.bocloud.fms.repository;

import com.bocloud.common.utils.MapTools;
import com.bocloud.fms.entity.FlowVariable;
import com.bocloud.database.core.intf.impl.BasicGenericDao;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * 流程参数变量
 *
 * @author zhangyf
 * @since 2020-09-02
 */
@Repository
public class FlowVariableRepository extends BasicGenericDao<FlowVariable, Long> {

    public FlowVariableRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate) {
        super(jdbcTemplate, npJdbcTemplate);
    }

    /**
     * 根据流程类型查询参数变量
     *
     * @param type 流程类型
     * @return
     */
    public List<FlowVariable> listByType(String type) {
        String sql = "SELECT * FROM wf_variable where is_deleted = 0 and type = :type";
        return super.list(FlowVariable.class, sql, MapTools.simpleMap("type", type));
    }

}
