package com.bocloud.fms.engine.freemarker;

import freemarker.cache.StringTemplateLoader;
import freemarker.template.Configuration;
import freemarker.template.Template;
import freemarker.template.TemplateException;

import java.io.IOException;
import java.io.StringWriter;
import java.util.Locale;

/**
 * FreeMarker工具类
 *
 * @author zhangyf
 * @since 2020-09-01
 */
public class FreeMarkerUtil {

    /**
     * 根据模板内容及数据生成最终结果
     *
     * @param templateContent 消息模板
     * @param dataModel       数据模型
     * @return
     * @throws IOException
     * @throws TemplateException
     */
    public static String getContent(String templateContent, Object dataModel) throws IOException, TemplateException {
        String templateName = "templateName";
        Configuration cfg = new Configuration(Configuration.VERSION_2_3_30);
        cfg.setClassicCompatible(true);
        cfg.setDefaultEncoding("UTF-8");
        cfg.setLocale(Locale.SIMPLIFIED_CHINESE);
        cfg.setNumberFormat("#");
        cfg.setDateFormat("yyyy-MM-dd");
        cfg.setTimeFormat("HH:mm:ss");
        cfg.setDateTimeFormat("yyyy-MM-dd HH:mm:ss");
        StringTemplateLoader templateLoader = new StringTemplateLoader();
        templateLoader.putTemplate(templateName, templateContent);
        cfg.setTemplateLoader(templateLoader);
        Template template = cfg.getTemplate(templateName);
        StringWriter result = new StringWriter();
        template.process(dataModel, result);
        return result.toString();
    }
}
