package com.bocloud.fms.engine.handlers.impl;

import com.bocloud.fms.service.Execution;

/**
 * @author hufy actor all方式的合并处理器
 */
public class MergeActorHandler extends AbstractMergeHandler {
    /**
     * 调用者需要提供actor all的任务名称
     */
    private String nodeName;

    /**
     * 构造函数，由调用者提供nodeName
     *
     * @param nodeName
     */
    public MergeActorHandler(String nodeName) {
        this.nodeName = nodeName;
    }

    /**
     * actor all方式，查询参数为：FlowInstanceId、nodeName
     *
     * @see com.bocloud.flow.engine.handlers.impl.AbstractMergeHandler#findActiveNodes()
     */
    @Override
    protected String[] findActiveNodes() {
        return new String[]{nodeName};
    }

    @Override
    protected Boolean isOkToMerge(Execution execution) {
        return true;
    }
}
