package com.bocloud.fms.engine.impl;

import com.bocloud.common.model.RequestContext;
import com.bocloud.fms.common.model.BasicDomainModel;
import com.bocloud.fms.engine.FlowInterceptor;
import com.bocloud.fms.engine.model.FlowNodeModel;
import com.bocloud.fms.entity.FlowNode;
import com.bocloud.fms.service.Execution;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 日志拦截器
 *
 * @author hufy
 */
public class LogInterceptor implements FlowInterceptor {
    private static final Logger log = LoggerFactory.getLogger(LogInterceptor.class);

    /**
     * 拦截产生的任务对象，打印日志
     */
    @Override
    public void intercept(Execution execution) {
        if (log.isInfoEnabled()) {
            for (BasicDomainModel<FlowNode, FlowNodeModel> task : execution.getTasks()) {
                StringBuffer buffer = new StringBuffer(100);
                buffer.append("创建任务[标识=").append(task.getEntity().getId());
                buffer.append(",名称=").append(task.getEntity().getName());
                buffer.append(",创建时间=").append(task.getEntity().getGmtCreate());
                buffer.append(",参与者={");
                if (task.getEntity().getActors() != null) {
                    for (RequestContext actor : task.getEntity().getActors()) {
                        buffer.append(actor.getCatalog() + ":" + actor.getTarget()).append(";");
                    }
                }
                buffer.append("}]");
                log.info(buffer.toString());
            }
        }
    }
}
