package com.bocloud.fms.engine.model;

import com.bocloud.fms.engine.handlers.IHandler;
import com.bocloud.fms.service.Execution;

import java.io.Serializable;

/**
 * 模型元素基类
 *
 * @author hufy
 */
public class BaseModel implements Serializable {
    /**
     *
     */
    private static final long serialVersionUID = 3082741431225739241L;
    /**
     * 元素名称
     */
    private String id;
    /**
     * 显示名称
     */
    private String name;

    /**
     * 将执行对象execution交给具体的处理器处理
     *
     * @param handler
     * @param execution
     */
    protected void fire(IHandler handler, Execution execution) {
        handler.handle(execution);
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
