package com.bocloud.fms.engine.model;

import com.bocloud.fms.service.Execution;
import lombok.Data;

import java.util.List;

/**
 * 任务定义task元素
 *
 * @author hufy
 */
@Data
public class FlowNodeModel extends AbstractWorkModel {
    /**
     *
     */
    private static final long serialVersionUID = 3780206509441461347L;

    /**
     * 参与者，指定人
     */
    private List<Long> assignee;
    /**
     * 角色
     */
    private List<Long> assigneeRole;
    /**
     * 租户管理员
     */
    private Boolean assigneeTenantAdmin;
    /**
     * 项目经理
     */
    private Boolean assigneeProjectManager;
    /**
     * 是否自动执行
     */
    private Boolean autoExecute;
    /**
     * 收到审批任务通知模板
     */
    private String msgTemplateReceive;
    /**
     * 通过审批结果通知模板
     */
    private String msgTemplateApproved;
    /**
     * 拒绝审批结果通知模板
     */
    private String msgTemplateUnratified;

    @Override
    protected void exec(Execution execution) {
        runOutTransition(execution);
    }
}
