package com.bocloud.fms.engine.model;

import com.bocloud.fms.engine.Action;
import com.bocloud.fms.engine.handlers.impl.CreateTaskHandler;
import com.bocloud.fms.service.Execution;

/**
 * 变迁定义transition元素
 *
 * @author hufy
 */
public class TransitionModel extends BaseModel implements Action {

    /**
     *
     */
    private static final long serialVersionUID = 3688123410411321158L;
    /**
     * 变迁的源节点引用
     */
    private BaseNodeModel source;
    /**
     * 变迁的目标节点引用
     */
    private BaseNodeModel target;
    /**
     * 变迁的目标节点name名称
     */
    private String to;
    /**
     * 当前变迁路径是否可用
     */
    private boolean enabled = false;

    /**
     * pass 和 nopass
     */
    private String auditFlag;

    /**
     * 条件表达式
     */
    private String expression;

    @Override
    public void execute(Execution execution) {
        if (!enabled) {
            return;
        }
        if (target instanceof AuditTaskModel) {
            // 如果目标节点模型为TaskModel，则创建task
            fire(new CreateTaskHandler((AuditTaskModel) target), execution);
        } else if (target instanceof FlowNodeModel) {
            // 如果目标节点模型为TaskModel，则创建task
            fire(new CreateTaskHandler((FlowNodeModel) target), execution);
        } else {
            // 如果目标节点模型为其它控制类型，则继续由目标节点执行
            target.execute(execution);
        }
    }

    public BaseNodeModel getSource() {
        return source;
    }

    public void setSource(BaseNodeModel source) {
        this.source = source;
    }

    public BaseNodeModel getTarget() {
        return target;
    }

    public void setTarget(BaseNodeModel target) {
        this.target = target;
    }

    public String getTo() {
        return to;
    }

    public void setTo(String to) {
        this.to = to;
    }

    public boolean isEnabled() {
        return enabled;
    }

    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }

    public String getAuditFlag() {
        return auditFlag;
    }

    public void setAuditFlag(String auditFlag) {
        this.auditFlag = auditFlag;
    }

    public String getExpression() {
        return expression;
    }

    public void setExpression(String expression) {
        this.expression = expression;
    }

}
