package com.bocloud.fms.engine.parser;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.fms.engine.model.BaseNodeModel;

/**
 * 节点解析接口
 *
 * @author hufy
 */
public interface NodeParser {

    String GRAPH = "graph";
    /**
     * 变迁节点名称
     */
    String NODE_TRANSITION = "transition";

    /**
     * 变迁节点名称
     */
    String NODE_TRANSITIONS = "transitions";

    /**
     * 节点属性类型
     */
    String ATTR_TYPE = "type";
    /**
     * 节点属性ID
     */
    String ATTR_ID = "id";
    /**
     * 显示名称
     */
    String ATTR_NAME = "name";

    /**
     * // 审核标识
     */
    String ATTR_AUDITFLAG = "auditFlag";
    /**
     * 被指派人
     */
    String ATTR_ASSIGNEE = "assignee";
    /**
     * 被指派角色
     */
    String ATTR_ASSIGNEE_ROLE = "assigneeRole";
    /**
     * 被指派租户管理员
     */
    String ATTR_ASSIGNEE_TENANT_ADMIN = "assigneeTenantAdmin";
    /**
     * 被指派项目经理
     */
    String ATTR_ASSIGNEE_PROJECT_MANAGER = "assigneeProjectManager";
    /**
     * 下一个节点
     */
    String ATTR_TO = "to";
    /**
     * 流程名称
     */
    String ATTR_PROCESSNAME = "definitionName";
    /**
     * 版本号
     */
    String ATTR_VERSION = "version";
    /**
     * 过期时间
     */
    String ATTR_EXPIRETIME = "expireTime";
    /**
     * 提醒时间
     */
    String ATTR_REMINDERTIME = "reminderTime";
    /**
     * 重复提醒次数
     */
    String ATTR_REMINDERREPEAT = "reminderRepeat";
    /**
     * 备注
     */
    String ATTR_REMARK = "remark";
    /**
     * 自动执行
     */
    String ATTR_AUTOEXECUTE = "autoExecute";

    /**
     * 节点dom元素解析方法，由实现类完成解析
     *
     * @param node jsonObject
     */
    void parse(JSONObject node);

    /**
     * 解析成功后，提供返回NodeModel模型对象
     *
     * @return 节点模型
     */
    BaseNodeModel getModel();
}
