package com.bocloud.fms.engine.parser.impl;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.fms.engine.model.AuditTaskModel;
import com.bocloud.fms.engine.model.BaseNodeModel;
import com.bocloud.fms.engine.model.FlowNodeModel;
import com.bocloud.fms.engine.parser.AbstractNodeParser;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Component;

/**
 * * @author hufy 审核节点
 */
@Component("auditTaskNodeParser")
public class AuditTaskNodeParser extends AbstractNodeParser {
    @Override
    protected BaseNodeModel newModel() {
        return new AuditTaskModel();
    }

    @Override
    protected void parseNode(BaseNodeModel model, JSONObject node) {
        FlowNodeModel task = (FlowNodeModel) model;
        if (StringUtils.isNotBlank(node.getString(ATTR_ASSIGNEE))) {
            task.setAssignee(JSONObject.parseArray(node.getString(ATTR_ASSIGNEE), Long.class));
        }
        if (StringUtils.isNotBlank(node.getString(ATTR_ASSIGNEE_ROLE))) {
            task.setAssigneeRole(JSONObject.parseArray(node.getString(ATTR_ASSIGNEE_ROLE), Long.class));
        }
        task.setAssigneeTenantAdmin(node.getBoolean(ATTR_ASSIGNEE_TENANT_ADMIN));
        task.setAssigneeProjectManager(node.getBoolean(ATTR_ASSIGNEE_PROJECT_MANAGER));
        task.setAutoExecute(node.getBoolean(ATTR_AUTOEXECUTE));
        task.setMsgTemplateReceive(node.getString("msgTemplateReceive"));
        task.setMsgTemplateApproved(node.getString("msgTemplateApproved"));
        task.setMsgTemplateUnratified(node.getString("msgTemplateUnratified"));
    }
}
