package com.bocloud.fms.engine.spring;

import com.bocloud.fms.engine.Expression;
import org.springframework.expression.EvaluationContext;
import org.springframework.expression.ExpressionParser;
import org.springframework.expression.spel.standard.SpelExpressionParser;
import org.springframework.expression.spel.support.StandardEvaluationContext;

import java.util.Map;
import java.util.Map.Entry;

/**
 * * @author hufy Spring el表达式解析器
 */
public class SpelExpression implements Expression {
    ExpressionParser parser = new SpelExpressionParser();

    @Override
    public <T> T eval(Class<T> tClass, String expr, Map<String, Object> args) {
        EvaluationContext context = new StandardEvaluationContext();
        for (Entry<String, Object> entry : args.entrySet()) {
            context.setVariable(entry.getKey(), entry.getValue());
        }
        return parser.parseExpression(expr).getValue(context, tClass);
    }
}
