package com.bocloud.fms.service;

import com.bocloud.fms.engine.Completion;
import com.bocloud.fms.engine.impl.GeneralCompletion;
import com.bocloud.fms.intf.FlowDefinitionService;
import com.bocloud.fms.repository.FlowDefinitionRepository;
import com.bocloud.fms.repository.FlowInstanceRepository;
import com.bocloud.fms.repository.FlowNodeActorRepository;
import com.bocloud.fms.repository.FlowNodeRepository;
import com.bocloud.fms.service.internal.SmsRoleService;
import com.bocloud.fms.service.internal.SmsTenantService;
import com.bocloud.fms.service.internal.SmsUserService;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 作为抽象父类，提供给子类access实现方式
 *
 * @author hufy
 */
public abstract class AbstractAccessService {

    @Autowired
    protected FlowInstanceRepository flowInstanceRepository;
    @Autowired
    protected FlowNodeRepository flowNodeRepository;
    @Autowired
    protected FlowNodeActorRepository flowNodeActorRepository;
    @Autowired
    protected FlowDefinitionRepository flowDefinitionRepository;
    @Autowired
    protected SmsUserService smsUserService;
    @Autowired
    protected SmsTenantService smsTenantService;
    @Autowired
    protected FlowDefinitionService flowDefinitionService;
    @Autowired
    protected SmsRoleService smsRoleService;
    /**
     * 完成触发接口
     */
    private Completion completion = null;


    public FlowInstanceRepository getFlowInstanceRepository() {
        return flowInstanceRepository;
    }

    public FlowNodeRepository getFlowNodeRepository() {
        return flowNodeRepository;
    }

    public FlowNodeActorRepository getFlowNodeActorRepository() {
        return flowNodeActorRepository;
    }

    public FlowDefinitionRepository getFlowDefinitionRepository() {
        return flowDefinitionRepository;
    }

    public Completion getCompletion() {
        if (completion != null) {
            return completion;
        }
        completion = AbstractServiceContext.find(Completion.class);
        if (completion == null) {
            AbstractServiceContext.put(Completion.class.getName(), GeneralCompletion.class);
            completion = AbstractServiceContext.find(Completion.class);
        }
        return completion;
    }
}
